////////////////////////////////////////////////////////////////////////////
////                           EX_CCPMP.C                               ////
////                                                                    ////
////  This program will show how to use the built in CCP to             ////
////  measure a pulse width.                                            ////
////                                                                    ////
////////////////////////////////////////////////////////////////////////////
////        (C) Copyright 1996,1997 Custom Computer Services            ////
//// This source code may only be used by licensed users of the CCS C   ////
//// compiler.  This source code may only be distributed to other       ////
//// licensed users of the CCS C compiler.  No other use, reproduction  ////
//// or distribution is permitted without written permission.           ////
//// Derivative programs created using this software in object code     ////
//// form are not restricted in any way.                                ////
////////////////////////////////////////////////////////////////////////////

#include <SX52BD.H>
#include "atd_emu.h"

#fuses HS,NOWDT,NOPROTECT

#use delay(clock=16000000)
#use rs232(baud=19200, xmit=PIN_A3, rcv=PIN_A2)

#use standard_io(B)
#use standard_io(C)

long rise,fall,pulse_width;

#int_T2_capt
void isr() {
   rise = GET_TIMER1_CAPT(1);
   fall = GET_TIMER2_CAPT(1);
   printf("captured");
//   pulse_width = fall - rise;     // CCP_1 is the time the pulse went high
}                                 // CCP_2 is the time the pulse went low
                                  // pulse_width/(clock) is the time

                                  // In order for this to work the ISR
                                  // overhead must be less than the
                                  // low time.  For this program the
                                  // overhead is 45 instructions.  The
                                  // low time must then be at least
                                  // 9 us.

main() {
   set_mode_a(mTTLIN,mTTLIN,mTTLIN,mTTLIN,mOUTPUT,mTTLIN,mTTLIN,mTTLIN);

   pulse_width=0;

   printf("\r\nHigh time (sampled every second):\r\n");
   setup_timer_1 (tCC|CAPT_L2H, DIV_BY_1, 0, 0);    // Start timer 1
   setup_timer_2 (tCC|CAPT_H2L|CAPT_INT, DIV_BY_1, 0, 0);    // Start timer 2

   while(TRUE) {
      delay_ms(1000);
      pulse_width++;
      printf("\r%lx us      ", pulse_width );
   }

}
