///////////////////////////////////////////////////////////////////////////
////                         EX_TEMP.C                                 ////
////                                                                   ////
////  Reads temperature using the DS1621 and sends it over the RS232   ////
////                                                                   ////
////  Pin layout for the DS1621:                                       ////
////                                                                   ////
////  SX Chip      DS1621                                              ////
////  -------------------                                              ////
////  PIN_B7  --->  PIN 1                                              ////
////  PIN_B6  --->  PIN 2                                              ////
////  GND     --->  PIN 4,5,6,7                                        ////
////  +5      --->  PIN 8                                              ////
////                                                                   ////
////  Pin 1 and 2 on the DS1621 should also be connected to +5 by way  ////
////  of a 1K resistor.                                                ////
////                                                                   ////
///////////////////////////////////////////////////////////////////////////
////        (C) Copyright 1996,1997 Custom Computer Services            ////
//// This source code may only be used by licensed users of the CCS C   ////
//// compiler.  This source code may only be distributed to other       ////
//// licensed users of the CCS C compiler.  No other use, reproduction  ////
//// or distribution is permitted without written permission.           ////
//// Derivative programs created using this software in object code     ////
//// form are not restricted in any way.                                ////
////////////////////////////////////////////////////////////////////////////

#include <SX28ac.H>
#include "atd_emu.h"

#fuses HS,NOWDT,NOPROTECT

#use delay(clock=16000000)
#use rs232(baud=19200, xmit=PIN_A3, rcv=PIN_A2)

#include <ds1621.c>

main()
{
   byte value;

   set_mode_a(mTTLIN,mTTLIN,mTTLIN,mTTLIN,mOUTPUT,mTTLIN,mTTLIN,mTTLIN);

   init_temp();

   do {
      value = read_temp();
      printf("%u\r\n",value);
      delay_ms(1000);
   } while (TRUE);
}
