/////////////////////////////////////////////////////////////////////////
////                          SX_ADMM.C                              ////
////                                                                 ////
////  This program displays the min and max of 30 A/D samples over   ////
////  the RS-232 interface.  The process is repeated forever.        ////
////  An LTC1298 is used as the a/d converter.                       ////
////                                                                 ////
////  Pin layout for the LTC1298:                                    ////
////                                                                 ////
////  SX Chip     LTC1298                                            ////
////  -------------------                                            ////
////  PIN_B0  --->  PIN 7                                            ////
////  PIN_B1  --->  PIN 6                                            ////
////  PIN_B2  --->  PIN 5                                            ////
////  PIN_B3  --->  PIN 1                                            ////
////  GND     --->  PIN 4                                            ////
////  +5      --->  PIN 8                                            ////
////                                                                 ////
////  Analog CH0 and CH1 are on pins 2 and 3 respectivly of the      ////
////  LTC1298                                                        ////
////                                                                 ////
/////////////////////////////////////////////////////////////////////////
////        (C) Copyright 1996,1997 Custom Computer Services            ////
//// This source code may only be used by licensed users of the CCS C   ////
//// compiler.  This source code may only be distributed to other       ////
//// licensed users of the CCS C compiler.  No other use, reproduction  ////
//// or distribution is permitted without written permission.           ////
//// Derivative programs created using this software in object code     ////
//// form are not restricted in any way.                                ////
////////////////////////////////////////////////////////////////////////////

#include <SX28AC.H>
#fuses   HS,NOPROTECT,NOWDT
#use delay(clock=16000000)

#include <LTC1298.C>

#use rs232(baud=19200, xmit=PIN_A3, rcv=PIN_A2)

main() {

   int i;
   long int min,max,value;
   set_mode_a(mTTLIN,mTTLIN,mTTLIN,mTTLIN,mOUTPUT,mTTLIN,mTTLIN,mTTLIN);
   set_mode_b(mOUTPUT,mOUTPUT,mOUTPUT,mOUTPUT,mOUTPUT,mOUTPUT,mTTLIN,mOUTPUT);

   adc_init();
   printf("Sampling:");


   do {
      min=500;
      max=0;
      for(i=0;i<=30;++i) {
         delay_ms(100);
         value = read_analog(0);
         if(value<min)
            min=value;
         if(value>max)
            max=value;
      }
      printf("\n\rMin: %lx  Max: %lx\r\n",min,max);

   } while (TRUE);

}
