////////////////////////////////////////////////////////////////////////////
////                           SX_CCP1S.C                               ////
////                                                                    ////
////  This program will show how to use the built in CCP to             ////
////  generate a single pulse of a predefined time in response          ////
////  to a pushbutton                                                   ////
////                                                                    ////
////  Connect a button on the SX 28/52 demo board to RB0.  RB0 is to be ////
////  pulled down by a 5k resistor.  Output pulse is at pin RB6         ////
////                                                                    ////
////////////////////////////////////////////////////////////////////////////
////        (C) Copyright 1996,1997 Custom Computer Services            ////
//// This source code may only be used by licensed users of the CCS C   ////
//// compiler.  This source code may only be distributed to other       ////
//// licensed users of the CCS C compiler.  No other use, reproduction  ////
//// or distribution is permitted without written permission.           ////
//// Derivative programs created using this software in object code     ////
//// form are not restricted in any way.                                ////
////////////////////////////////////////////////////////////////////////////

#include <SX52BD.H>

#use Delay(Clock=16000000)
#use rs232(baud=19200, xmit=PIN_A3, rcv=PIN_A2)

boolean pulsed;

void clear_timer1() {
   #ASM
   mov   W, #0x10
   mov   M,W
   mov   !B,W
   #ENDASM
}


#INT_T1_COMP
void check_timer() {
   if (!pulsed)
     pulsed=TRUE;
   else
     clear_timer1();
}


main() {
   boolean pulsed;
   set_mode_a(mTTLIN,mTTLIN,mTTLIN,mTTLIN,mOUTPUT,mTTLIN,mTTLIN,mTTLIN);
   set_mode_b(mTTLIN,mOUTPUT,mTTLIN,mTTLIN,mTTLIN,mTTLIN,mTTLIN,mTTLIN);
   output_low(PIN_B6);
   
      while(TRUE) {
      printf("\r\nWaiting for button press:");
       while (!(input(PIN_B0))) ;    // Wait for keypress
      printf("\r\nButton pressed.\r\n");

       setup_timer_1(tPWM | COMP_INT, DIV_BY_128, 1, 12500);
       //pulse is up for 0.1sec

       delay_ms(1000);           // Debounce - Permit only one pulse per sec
   }

}
