/////////////////////////////////////////////////////////////////////////
////                             SX_PGEN.C                           ////
////                                                                 ////
////  This program is used for the PGEN board sold with the exp kit. ////
////  The board has two 10 pos switches one controls the high time   ////
////  and the other the low time of the pulses.  If a switch is in   ////
////  the 0 position it will wait for the button to be pressed and   ////
////  then issue a single pulse.                                     ////
/////////////////////////////////////////////////////////////////////////
#include <SX52BD.h>

#fuses HS,NOWDT,NOPROTECT

#use delay(clock=16000000)

#byte port_b = 6

void wait(byte time) {
   switch(time) {
     case 0 : break;
     case 1 : delay_us(100);  break;
     case 2 : delay_ms(1);    break;
     case 3 : delay_ms(10);   break;
     case 4 : delay_ms(25);   break;
     case 5 : delay_ms(50);   break;
     case 6 : delay_ms(100);  break;
     case 7 : delay_ms(250);  break;
     case 8 : delay_ms(500);  break;
     case 9 : delay_ms(1000); break;
   }
}

void read_selections(int & sw1, int & sw2) {
      sw1 = (~(port_b >> 4))&15;
      sw2 = (~(port_b & 15))&15;
}

main() {
   byte high_time, low_time;
#define one_shot_selected ((high_time==0)||(low_time==0))

   while (TRUE) {

      read_selections(high_time, low_time);

      if(high_time==0)
        output_high(pin_a0);
      else
        output_low(pin_a0);

      while ((one_shot_selected) && input(pin_a1))
         read_selections(high_time, low_time);

      output_high(pin_a0);
      wait(high_time);
      output_low(pin_a0);
      wait(low_time);

      if( one_shot_selected )
        delay_ms(1500);
   }
}
