/////////////////////////////////////////////////////////////////////////
////                           SX_PWM.C                              ////
////                                                                 ////
////  This program will show how to use the RTCC to generate PWM.    ////
////  The frequency and duty cycle is set by the user over RS232.    ////
////                                                                 ////
////  Output signal at RB6.                                          ////
////                                                                 ////
/////////////////////////////////////////////////////////////////////////
////        (C) Copyright 1996,1997 Custom Computer Services            ////
//// This source code may only be used by licensed users of the CCS C   ////
//// compiler.  This source code may only be distributed to other       ////
//// licensed users of the CCS C compiler.  No other use, reproduction  ////
//// or distribution is permitted without written permission.           ////
//// Derivative programs created using this software in object code     ////
//// form are not restricted in any way.                                ////
////////////////////////////////////////////////////////////////////////////

#include <SX28AC.H>

#use Delay(Clock=16000000)
#use rs232(baud=19200, xmit=PIN_A3, rcv=PIN_A2)


void menu() {
//seperated so it would fit within page segments
   printf("\r\nFrequency:\r\n");
   printf("    1) 19.5 khz (50%% duty cycle)\r\n");
   printf("    2) 4.9 khz (50%% duty cycle)\r\n");
   printf("    3) 1.2 khz (75%% duty cycle)\r\n");
   printf("    4) 1.2 khz (50%% duty cycle)\r\n");
   printf("    5) 1.2 khz (25%% duty cycle)\r\n");
}

main() {
   char selection;
   byte value;

   set_mode_a(mTTLIN,mTTLIN,mTTLIN,mTTLIN,mOUTPUT,mTTLIN,mTTLIN,mTTLIN);
   set_mode_b(mTTLIN,mOUTPUT,mTTLIN,mTTLIN,mTTLIN,mTTLIN,mTTLIN,mTTLIN);

   while ( TRUE ) {

   menu();

   do {
     selection=getc();
   } while((selection<'1')||(selection>'5'));

   switch(selection) {

      // 16,000,000/divisor * 100 * 2

     case '1' : setup_timer_1(tPWM, DIV_BY_1, 410, 410);
      //(16,000,000/div_by_1)/(417*2)=19,500 Hz
  printf("19.5khz\r\n");
                break;
     case '2' : setup_timer_1(tPWM, DIV_BY_4, 410, 410);
  printf("4.9khz\r\n");
                break;
     case '3' : setup_timer_1(tPWM, DIV_BY_16, 205, 615);
  printf("1.2khz 75%%\r\n");
                break;
     case '4' : setup_timer_1(tPWM, DIV_BY_16, 410, 410);
      printf("1.2khz 50%%\r\n");
                break;
     case '5' : setup_timer_1(tPWM, DIV_BY_16, 615, 205);
      printf("1.2khz 25%%\r\n");
                break;
   }

  }

}
